#ifndef MAINWINDOW_H
#define MAINWINDOW_H
#include "./ui_mainwindow.h"

#include <QMainWindow>
#include <QPushButton>
#include <QGridLayout>
#include <QLCDNumber>
#include <QTimer>
#include <QGraphicsScene>
#include <QBrush>
#include <QColor>

#include <rclcpp/rclcpp.hpp>
#include <std_msgs/msg/string.hpp>
#include <std_msgs/msg/char.hpp>
#include <std_msgs/msg/bool.hpp>
#include <std_msgs/msg/int32.hpp>
#include <std_msgs/msg/u_int8_multi_array.hpp>
#include <std_msgs/msg/header.hpp>
#include <sensor_msgs/msg/image.hpp>

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    void img_callback(const sensor_msgs::msg::Image::SharedPtr img);

public slots:

    void onTimer_Tick();   
private slots:

private:
    Ui::Form *ui;
    QGraphicsScene* graphicsScene;
    QGraphicsView* graphicsView;
    QTimer *timer_chrono;

    QPushButton *m_bout_publish;
    QGridLayout *m_layout;
};

#endif // MAINWINDOW_H
