#include "./../include/mainwindow.hpp"

std::shared_ptr<rclcpp::Node> node = nullptr;
rclcpp::Publisher<std_msgs::msg::Int32>::SharedPtr publisher_mode;
rclcpp::Publisher<std_msgs::msg::UInt8MultiArray>::SharedPtr publisher_rgb_low;
rclcpp::Subscription<sensor_msgs::msg::Image>::SharedPtr subscriber_img;
//=========================================================================
MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent)
 //   ui(new Ui::Form)
{
  //  ui->setupUi(this);

    this->setMinimumSize(800, 800);
    this->setWindowTitle("ROS2 RECEIVE CAM IHM");

    QWidget *zoneCentrale = new QWidget;
    setCentralWidget(zoneCentrale);

    graphicsScene = new QGraphicsScene();
    graphicsView = new QGraphicsView();
    QBrush background_scene(QColor(0, 0, 0));
    graphicsScene->setBackgroundBrush(background_scene);
    graphicsView->setScene(graphicsScene);

     m_layout = new QGridLayout();
     m_layout->addWidget(graphicsView,0,0);
    zoneCentrale->setLayout(m_layout);

    node = std::make_shared<rclcpp::Node>("PC_HOST_Node");

    timer_chrono = new QTimer();

    connect( timer_chrono, SIGNAL(timeout()), this, SLOT(onTimer_Tick()));

    subscriber_img = node->create_subscription<sensor_msgs::msg::Image>(
        "/camera/src_frame", 1000,std::bind(&MainWindow::img_callback, this, std::placeholders::_1));//"/topic/IMAGE_frame"
    timer_chrono -> start(5); // 5 ms

    RCLCPP_INFO(node->get_logger(), "Robot Gui Started");
}
//=========================================================================
void MainWindow::onTimer_Tick()
{
    rclcpp::spin_some(node);
}

MainWindow::~MainWindow()
{
   // delete ui;
}

//=========================================================================
void MainWindow::img_callback(const sensor_msgs::msg::Image::SharedPtr img)
{
    //Converting the ROS image to a Qimage (encoding: RGB8)
    QImage image(img->data.data(), img->width, img->height, QImage::Format_RGB888);

    //Display Image in QGraphicsScene
    graphicsScene->clear();
    graphicsScene->addPixmap(QPixmap::fromImage(image));

}





